#define Validate_RiDeclare \
{ \
	if(!ValidateState(9, Outside, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiDeclare [" << GetStateAsString() << "]" << std::endl; \
		return(0); \
	} \
}

#define Validate_RiBegin \
{ \
	if(!ValidateState(1, Outside) ) \
	{ \
		std::cerr << "Invalid state for RiBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiEnd \
{ \
	if(!ValidateState(1, BeginEnd) ) \
	{ \
		std::cerr << "Invalid state for RiEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiFrameBegin \
{ \
	if(!ValidateState(1, BeginEnd) ) \
	{ \
		std::cerr << "Invalid state for RiFrameBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiFrameEnd \
{ \
	if(!ValidateState(1, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiFrameEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiWorldBegin \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiWorldBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiWorldEnd \
{ \
	if(!ValidateState(1, World) ) \
	{ \
		std::cerr << "Invalid state for RiWorldEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiFormat \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiFormat [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiFrameAspectRatio \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiFrameAspectRatio [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiScreenWindow \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiScreenWindow [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiCropWindow \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiCropWindow [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiProjection \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiProjection [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiClipping \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiClipping [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDepthOfField \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiDepthOfField [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiShutter \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiShutter [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPixelVariance \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiPixelVariance [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPixelSamples \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiPixelSamples [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPixelFilter \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiPixelFilter [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiExposure \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiExposure [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiImager \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiImager [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiQuantize \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiQuantize [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDisplay \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiDisplay [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiGaussianFilter
#define Validate_RiBoxFilter
#define Validate_RiTriangleFilter
#define Validate_RiCatmullRomFilter
#define Validate_RiSincFilter
#define Validate_RiDiskFilter
#define Validate_RiBesselFilter
#define Validate_RiHider \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiHider [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiColorSamples \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiColorSamples [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiRelativeDetail \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiRelativeDetail [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiOption \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiOption [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiAttributeBegin \
{ \
	if(!ValidateState(5, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiAttributeBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiAttributeEnd \
{ \
	if(!ValidateState(1, Attribute) ) \
	{ \
		std::cerr << "Invalid state for RiAttributeEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiColor \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiColor [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiOpacity \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiOpacity [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTextureCoordinates \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiTextureCoordinates [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiLightSource \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiLightSource [" << GetStateAsString() << "]" << std::endl; \
		return(0); \
	} \
}

#define Validate_RiAreaLightSource \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiAreaLightSource [" << GetStateAsString() << "]" << std::endl; \
		return(0); \
	} \
}

#define Validate_RiIlluminate \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiIlluminate [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSurface \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiSurface [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiAtmosphere \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiAtmosphere [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiInterior \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiInterior [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiExterior \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiExterior [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiShadingRate \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiShadingRate [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiShadingInterpolation \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiShadingInterpolation [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMatte \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiMatte [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiBound \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiBound [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDetail \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiDetail [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDetailRange \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiDetailRange [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiGeometricApproximation \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiGeometricApproximation [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiOrientation \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiOrientation [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiReverseOrientation \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiReverseOrientation [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSides \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiSides [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiIdentity \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiIdentity [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTransform \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiTransform [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiConcatTransform \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiConcatTransform [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPerspective \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPerspective [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTranslate \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiTranslate [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiRotate \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiRotate [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiScale \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiScale [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSkew \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiSkew [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDeformation \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiDeformation [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDisplacement \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiDisplacement [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiCoordinateSystem \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiCoordinateSystem [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTransformPoints \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiTransformPoints [" << GetStateAsString() << "]" << std::endl; \
		return(0); \
	} \
}

#define Validate_RiTransformBegin \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiTransformBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTransformEnd \
{ \
	if(!ValidateState(1, Transform) ) \
	{ \
		std::cerr << "Invalid state for RiTransformEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiAttribute \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiAttribute [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPolygon \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPolygon [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiGeneralPolygon \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiGeneralPolygon [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPointsPolygons \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPointsPolygons [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPointsGeneralPolygons \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPointsGeneralPolygons [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiBasis \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiBasis [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPatch \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPatch [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPatchMesh \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPatchMesh [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiNuPatch \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiNuPatch [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTrimCurve \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiTrimCurve [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSphere \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiSphere [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiCone \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiCone [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiCylinder \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiCylinder [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiHyperboloid \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiHyperboloid [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiParaboloid \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiParaboloid [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiDisk \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiDisk [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiTorus \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiTorus [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiProcedural \
{ \
	if(!ValidateState(5, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiProcedural [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiGeometry \
{ \
	if(!ValidateState(5, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiGeometry [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSolidBegin \
{ \
	if(!ValidateState(5, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiSolidBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSolidEnd \
{ \
	if(!ValidateState(1, Solid) ) \
	{ \
		std::cerr << "Invalid state for RiSolidEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiObjectBegin \
{ \
	if(!ValidateState(6, BeginEnd, Frame, World, Attribute, Transform, Solid) ) \
	{ \
		std::cerr << "Invalid state for RiObjectBegin [" << GetStateAsString() << "]" << std::endl; \
		return(0); \
	} \
}

#define Validate_RiObjectEnd \
{ \
	if(!ValidateState(1, Object) ) \
	{ \
		std::cerr << "Invalid state for RiObjectEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiObjectInstance \
{ \
	if(!ValidateState(5, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiObjectInstance [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMotionBegin \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiMotionBegin [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMotionBeginV \
{ \
	if(!ValidateState(7, BeginEnd, Frame, World, Attribute, Transform, Solid, Object) ) \
	{ \
		std::cerr << "Invalid state for RiMotionBeginV [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMotionEnd \
{ \
	if(!ValidateState(1, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiMotionEnd [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMakeTexture \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiMakeTexture [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMakeBump \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiMakeBump [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMakeLatLongEnvironment \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiMakeLatLongEnvironment [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMakeCubeFaceEnvironment \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiMakeCubeFaceEnvironment [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMakeShadow \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiMakeShadow [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiMakeOcclusion \
{ \
	if(!ValidateState(2, BeginEnd, Frame) ) \
	{ \
		std::cerr << "Invalid state for RiMakeOcclusion [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiElse
#define Validate_RiElseIf
#define Validate_RiIfEnd
#define Validate_RiIfBegin
#define Validate_RiErrorHandler \
{ \
	if(!ValidateState(9, Outside, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiErrorHandler [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiErrorIgnore
#define Validate_RiErrorPrint
#define Validate_RiErrorAbort
#define Validate_RiArchiveRecord
#define Validate_RiGetContext
#define Validate_RiContext
#define Validate_RiClippingPlane
#define Validate_RiCoordSysTransform
#define Validate_RiBlobby \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiBlobby [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiPoints \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiPoints [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiCurves \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiCurves [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiSubdivisionMesh \
{ \
	if(!ValidateState(6, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiSubdivisionMesh [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiReadArchive
#define Validate_RiProcFree
#define Validate_RiProcDelayedReadArchive
#define Validate_RiProcRunProgram
#define Validate_RiProcDynamicLoad
#define Validate_RiShaderLayer \
{ \
	if(!ValidateState(8, BeginEnd, Frame, World, Attribute, Transform, Solid, Object, Motion) ) \
	{ \
		std::cerr << "Invalid state for RiShaderLayer [" << GetStateAsString() << "]" << std::endl; \
		return; \
	} \
}

#define Validate_RiConnectShaderLayers
