/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     SYMBOL = 259,
     ARRAY_SYMBOL = 260,
     TYPE_FLOAT = 261,
     TYPE_POINT = 262,
     TYPE_STRING = 263,
     TYPE_COLOR = 264,
     TYPE_NORMAL = 265,
     TYPE_VECTOR = 266,
     TYPE_VOID = 267,
     TYPE_MATRIX = 268,
     TYPE_UNIFORM = 269,
     TYPE_VARYING = 270,
     SHADER_TYPE_SURFACE = 271,
     SHADER_TYPE_VOLUME = 272,
     SHADER_TYPE_IMAGER = 273,
     SHADER_TYPE_TRANSFORMATION = 274,
     SHADER_TYPE_DISPLACEMENT = 275,
     SHADER_TYPE_LIGHT = 276,
     SHADER_TYPE_ATMOSPHERE = 277,
     ATTRIBUTE = 278,
     OPTION = 279,
     RENDERERINFO = 280,
     INCIDENT = 281,
     OPPOSITE = 282,
     LIGHTSOURCE = 283,
     EXTERN = 284,
     TEXTUREINFO = 285,
     OUTPUT = 286,
     IF = 287,
     ELSE = 288,
     WHILE = 289,
     FOR = 290,
     CONTINUE = 291,
     BREAK = 292,
     RETURN = 293,
     ILLUMINATE = 294,
     ILLUMINANCE = 295,
     SOLAR = 296,
     TEXTUREMAP = 297,
     ENVIRONMENT = 298,
     BUMP = 299,
     SHADOW = 300,
     OCCLUSION = 301,
     SETXCOMP = 302,
     SETYCOMP = 303,
     SETZCOMP = 304,
     SETCOMP = 305,
     DIV_ASSIGN = 306,
     MUL_ASSIGN = 307,
     SUB_ASSIGN = 308,
     ADD_ASSIGN = 309,
     OR_OP = 310,
     AND_OP = 311,
     NE_OP = 312,
     EQ_OP = 313,
     LE_OP = 314,
     GE_OP = 315,
     NEG = 316,
     FLOAT_CONSTANT = 317,
     STRING_LITERAL = 318
   };
#endif
#define IDENTIFIER 258
#define SYMBOL 259
#define ARRAY_SYMBOL 260
#define TYPE_FLOAT 261
#define TYPE_POINT 262
#define TYPE_STRING 263
#define TYPE_COLOR 264
#define TYPE_NORMAL 265
#define TYPE_VECTOR 266
#define TYPE_VOID 267
#define TYPE_MATRIX 268
#define TYPE_UNIFORM 269
#define TYPE_VARYING 270
#define SHADER_TYPE_SURFACE 271
#define SHADER_TYPE_VOLUME 272
#define SHADER_TYPE_IMAGER 273
#define SHADER_TYPE_TRANSFORMATION 274
#define SHADER_TYPE_DISPLACEMENT 275
#define SHADER_TYPE_LIGHT 276
#define SHADER_TYPE_ATMOSPHERE 277
#define ATTRIBUTE 278
#define OPTION 279
#define RENDERERINFO 280
#define INCIDENT 281
#define OPPOSITE 282
#define LIGHTSOURCE 283
#define EXTERN 284
#define TEXTUREINFO 285
#define OUTPUT 286
#define IF 287
#define ELSE 288
#define WHILE 289
#define FOR 290
#define CONTINUE 291
#define BREAK 292
#define RETURN 293
#define ILLUMINATE 294
#define ILLUMINANCE 295
#define SOLAR 296
#define TEXTUREMAP 297
#define ENVIRONMENT 298
#define BUMP 299
#define SHADOW 300
#define OCCLUSION 301
#define SETXCOMP 302
#define SETYCOMP 303
#define SETZCOMP 304
#define SETCOMP 305
#define DIV_ASSIGN 306
#define MUL_ASSIGN 307
#define SUB_ASSIGN 308
#define ADD_ASSIGN 309
#define OR_OP 310
#define AND_OP 311
#define NE_OP 312
#define EQ_OP 313
#define LE_OP 314
#define GE_OP 315
#define NEG 316
#define FLOAT_CONSTANT 317
#define STRING_LITERAL 318




/* Copy the first part of user declarations.  */
#line 5 "parser.yxx"

#ifdef	WIN32
#include <malloc.h>
#pragma warning(disable : 4786)
#include <cstdio>
#include <memory>
namespace std
{ using ::size_t; 
  using ::malloc;
  using ::free;
}
#endif

#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <cassert>

#include	"parsenode.h"
#include	"logging.h"

# define YYMAXDEPTH 100000
# define YYINITDEPTH  2000

using namespace Aqsis;


namespace Aqsis
{

extern CqString ParseStreamName;
extern std::ostream* ParseErrorStream;
extern TqInt ParseLineNumber;
extern TqBool ParseSucceeded;
extern TqInt	iArrayAccess;
CqParseNode*	ParseTreePointer;
std::vector<CqString>	ParseNameSpaceStack;
std::vector<TqInt>		FunctionReturnCountStack;
EqShaderType gShaderType;

TqBool	FindVariable(const char* name, SqVarRef& ref);
TqBool	FindFunction(const char* name, std::vector<SqFuncRef>& Ref);
CqString strNameSpace();
void	TypeCheck();
void	Optimise();
void	InitStandardNamespace();
void	ProcessShaderArguments( CqParseNode* pArgs );

}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 60 "parser.yxx"
typedef union YYSTYPE {
	CqParseNode::Pos m_Pos;
	CqParseNode*	m_pParseNode;
	TqInt			m_VarType;
	EqShaderType	m_ShaderType;
	TqFloat			m_FloatConst;
	CqString*	m_Identifier;
	struct{
		SqVarRef		VarRef;
		SqFuncRef		FuncRef;
		TqInt				eType;
	}				m_pSymbol;
	struct{
		TqInt				Type;
		CqString*	Space;
	}				m_TypeAndSpace;
	EqCommType		m_CommType;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 274 "parser.cxx"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 79 "parser.yxx"

extern TqInt yylex();
static void yyerror(const CqString Message);


/* Line 214 of yacc.c.  */
#line 290 "parser.cxx"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  41
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2333

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  84
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  47
/* YYNRULES -- Number of rules. */
#define YYNRULES  181
/* YYNRULES -- Number of states. */
#define YYNSTATES  390

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   318

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,     2,     2,     2,     2,     2,
      74,    75,    70,    66,    81,    67,    71,    69,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    57,    80,
      61,    51,    60,    56,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    82,     2,    83,    68,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,     2,    79,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    52,    53,    54,    55,
      58,    59,    62,    63,    64,    65,    73,    76,    77
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    13,    23,    33,
      42,    51,    58,    64,    68,    71,    75,    78,    80,    82,
      84,    86,    88,    90,    92,    96,    99,   102,   106,   109,
     113,   116,   118,   120,   124,   127,   129,   134,   140,   144,
     147,   149,   154,   160,   164,   167,   172,   174,   178,   180,
     182,   184,   186,   188,   190,   192,   194,   196,   198,   201,
     203,   206,   208,   211,   213,   216,   218,   221,   223,   225,
     227,   230,   233,   236,   239,   242,   246,   249,   251,   254,
     256,   260,   263,   265,   269,   273,   279,   285,   289,   293,
     303,   313,   318,   326,   332,   342,   348,   356,   366,   378,
     381,   383,   385,   387,   389,   393,   397,   401,   405,   409,
     413,   416,   418,   424,   427,   429,   431,   433,   435,   440,
     442,   444,   446,   448,   450,   454,   462,   496,   498,   500,
     502,   504,   506,   508,   512,   516,   520,   524,   527,   531,
     535,   539,   543,   547,   554,   561,   568,   575,   582,   587,
     591,   596,   600,   602,   606,   613,   619,   625,   630,   632,
     634,   636,   638,   640,   642,   646,   649,   653,   655,   657,
     659,   661,   663,   665,   667,   669,   671,   673,   675,   682,
     691,   698
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      85,     0,    -1,    86,    -1,    85,    86,    -1,    88,    -1,
      89,    -1,    -1,    91,     3,    87,    74,    92,    75,    78,
     109,    79,    -1,    91,     4,    87,    74,    92,    75,    78,
     109,    79,    -1,    91,     3,    87,    74,    75,    78,   109,
      79,    -1,    91,     4,    87,    74,    75,    78,   109,    79,
      -1,    90,    92,    75,    78,   109,    79,    -1,    90,    75,
      78,   109,    79,    -1,    95,     3,    74,    -1,     3,    74,
      -1,    95,     4,    74,    -1,     4,    74,    -1,    21,    -1,
      16,    -1,    17,    -1,    20,    -1,    19,    -1,    18,    -1,
      93,    -1,    92,    80,    93,    -1,    92,    80,    -1,    95,
      96,    -1,    31,    95,    96,    -1,    95,    96,    -1,    29,
      95,    96,    -1,   101,   102,    -1,   102,    -1,    97,    -1,
      96,    81,    97,    -1,     3,    98,    -1,     3,    -1,     3,
      82,   128,    83,    -1,     3,    82,   128,    83,    99,    -1,
       3,    82,    83,    -1,     4,    98,    -1,     4,    -1,     4,
      82,   128,    83,    -1,     4,    82,   128,    83,    99,    -1,
       4,    82,    83,    -1,    51,   114,    -1,    51,    78,   100,
      79,    -1,   114,    -1,   100,    81,   114,    -1,    15,    -1,
      14,    -1,     6,    -1,     8,    -1,    12,    -1,   103,    -1,
     104,    -1,   105,    -1,   106,    -1,   107,    -1,     7,   108,
      -1,     7,    -1,     9,   108,    -1,     9,    -1,    11,   108,
      -1,    11,    -1,    10,   108,    -1,    10,    -1,    13,   108,
      -1,    13,    -1,    77,    -1,   110,    -1,   109,   110,    -1,
     119,    80,    -1,   120,    80,    -1,   121,    80,    -1,   130,
      80,    -1,    38,   114,    80,    -1,   112,    80,    -1,   111,
      -1,    94,    80,    -1,    89,    -1,    78,   109,    79,    -1,
      78,    79,    -1,    80,    -1,    32,   118,   110,    -1,    32,
     114,   110,    -1,    32,   118,   110,    33,   110,    -1,    32,
     114,   110,    33,   110,    -1,    34,   118,   110,    -1,    34,
     114,   110,    -1,    35,    74,   114,    80,   118,    80,   114,
      75,   110,    -1,    35,    74,   114,    80,   114,    80,   114,
      75,   110,    -1,    41,    74,    75,   110,    -1,    41,    74,
     114,    81,   114,    75,   110,    -1,    39,    74,   114,    75,
     110,    -1,    39,    74,   114,    81,   114,    81,   114,    75,
     110,    -1,    40,    74,   114,    75,   110,    -1,    40,    74,
     114,    81,   114,    75,   110,    -1,    40,    74,   114,    81,
     114,    81,   114,    75,   110,    -1,    40,    74,   114,    81,
     114,    81,   114,    81,   114,    75,   110,    -1,   113,   128,
      -1,   113,    -1,    37,    -1,    36,    -1,   116,    -1,   114,
      71,   114,    -1,   114,    69,   114,    -1,   114,    70,   114,
      -1,   114,    68,   114,    -1,   114,    66,   114,    -1,   114,
      67,   114,    -1,    67,   114,    -1,   115,    -1,   118,    56,
     114,    57,   114,    -1,   102,   114,    -1,   128,    -1,   123,
      -1,     4,    -1,     5,    -1,     5,    82,   114,    83,    -1,
      77,    -1,   120,    -1,   121,    -1,   130,    -1,   119,    -1,
      74,   114,    75,    -1,    74,   114,    81,   114,    81,   114,
      75,    -1,    74,   114,    81,   114,    81,   114,    81,   114,
      81,   114,    81,   114,    81,   114,    81,   114,    81,   114,
      81,   114,    81,   114,    81,   114,    81,   114,    81,   114,
      81,   114,    81,   114,    75,    -1,    60,    -1,    65,    -1,
      61,    -1,    64,    -1,    63,    -1,    62,    -1,    74,   118,
      75,    -1,   114,   117,   114,    -1,   118,    59,   118,    -1,
     118,    58,   118,    -1,    72,   118,    -1,     4,    51,   114,
      -1,     4,    55,   114,    -1,     4,    54,   114,    -1,     4,
      53,   114,    -1,     4,    52,   114,    -1,     5,    82,   114,
      83,    51,   114,    -1,     5,    82,   114,    83,    55,   114,
      -1,     5,    82,   114,    83,    54,   114,    -1,     5,    82,
     114,    83,    53,   114,    -1,     5,    82,   114,    83,    52,
     114,    -1,     4,    74,   122,    75,    -1,     4,    74,    75,
      -1,     3,    74,   122,    75,    -1,     3,    74,    75,    -1,
     114,    -1,   122,    81,   114,    -1,   124,    74,   125,   126,
     127,    75,    -1,   124,    74,   125,   127,    75,    -1,   124,
      74,   125,   126,    75,    -1,   124,    74,   125,    75,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
     114,    -1,    82,   114,    83,    -1,    81,   114,    -1,   127,
      81,   114,    -1,    76,    -1,    22,    -1,    20,    -1,    28,
      -1,    16,    -1,    23,    -1,    24,    -1,    25,    -1,    26,
      -1,    27,    -1,    30,    -1,   129,    74,   114,    81,     4,
      75,    -1,   129,    74,   114,    81,   114,    81,     4,    75,
      -1,   129,    74,   114,    81,     5,    75,    -1,   129,    74,
     114,    81,   114,    81,     5,    75,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   169,   169,   170,   175,   176,   181,   188,   201,   217,
     224,   237,   276,   299,   307,   315,   328,   344,   347,   350,
     353,   356,   359,   365,   378,   389,   393,   464,   540,   615,
     666,   670,   674,   680,   688,   697,   704,   711,   720,   727,
     741,   751,   761,   773,   786,   792,   807,   813,   821,   822,
     826,   830,   834,   838,   839,   840,   841,   842,   846,   850,
     857,   861,   868,   872,   879,   883,   890,   894,   901,   905,
     911,   919,   920,   928,   936,   941,   950,   951,   952,   978,
     979,   980,   981,   982,   990,  1004,  1013,  1032,  1038,  1051,
    1066,  1088,  1094,  1108,  1117,  1133,  1146,  1160,  1177,  1198,
    1199,  1203,  1207,  1215,  1216,  1227,  1238,  1249,  1260,  1271,
    1282,  1292,  1293,  1306,  1352,  1356,  1357,  1361,  1365,  1370,
    1374,  1375,  1376,  1377,  1378,  1381,  1389,  1413,  1414,  1415,
    1416,  1417,  1418,  1422,  1425,  1432,  1439,  1446,  1454,  1460,
    1474,  1488,  1502,  1516,  1523,  1541,  1559,  1577,  1598,  1608,
    1619,  1641,  1657,  1663,  1671,  1685,  1699,  1705,  1714,  1720,
    1726,  1732,  1738,  1747,  1754,  1758,  1764,  1773,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1792,  1813,
    1843,  1864
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYMBOL", "ARRAY_SYMBOL", 
  "TYPE_FLOAT", "TYPE_POINT", "TYPE_STRING", "TYPE_COLOR", "TYPE_NORMAL", 
  "TYPE_VECTOR", "TYPE_VOID", "TYPE_MATRIX", "TYPE_UNIFORM", 
  "TYPE_VARYING", "SHADER_TYPE_SURFACE", "SHADER_TYPE_VOLUME", 
  "SHADER_TYPE_IMAGER", "SHADER_TYPE_TRANSFORMATION", 
  "SHADER_TYPE_DISPLACEMENT", "SHADER_TYPE_LIGHT", 
  "SHADER_TYPE_ATMOSPHERE", "ATTRIBUTE", "OPTION", "RENDERERINFO", 
  "INCIDENT", "OPPOSITE", "LIGHTSOURCE", "EXTERN", "TEXTUREINFO", 
  "OUTPUT", "IF", "ELSE", "WHILE", "FOR", "CONTINUE", "BREAK", "RETURN", 
  "ILLUMINATE", "ILLUMINANCE", "SOLAR", "TEXTUREMAP", "ENVIRONMENT", 
  "BUMP", "SHADOW", "OCCLUSION", "SETXCOMP", "SETYCOMP", "SETZCOMP", 
  "SETCOMP", "'='", "DIV_ASSIGN", "MUL_ASSIGN", "SUB_ASSIGN", 
  "ADD_ASSIGN", "'?'", "':'", "OR_OP", "AND_OP", "'>'", "'<'", "NE_OP", 
  "EQ_OP", "LE_OP", "GE_OP", "'+'", "'-'", "'^'", "'/'", "'*'", "'.'", 
  "'!'", "NEG", "'('", "')'", "FLOAT_CONSTANT", "STRING_LITERAL", "'{'", 
  "'}'", "';'", "','", "'['", "']'", "$accept", "file", "definitions", 
  "get_filepos", "shader_definition", "function_definition", 
  "function_declaration", "shader_type", "formals", 
  "formal_variable_definitions", "variable_definitions", "typespec", 
  "def_expressions", "def_expression", "def_init", 
  "def_array_initialisers", "array_initialisers", "detail", "type", 
  "pspace", "cspace", "vspace", "nspace", "mspace", "spacetype", 
  "statements", "statement", "loop_control", "loop_modstmt", "loop_mod", 
  "expression", "cast_expr", "primary", "relational_operator", "relation", 
  "assignexpression", "procedurecall", "unresolvedcall", "proc_arguments", 
  "texture", "texture_type", "texture_filename", "channel", 
  "texture_arguments", "number", "comm_type", "comm_function", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    61,   306,   307,   308,   309,    63,    58,   310,   311,
      62,    60,   312,   313,   314,   315,    43,    45,    94,    47,
      42,    46,    33,   316,    40,    41,   317,   318,   123,   125,
      59,    44,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    84,    85,    85,    86,    86,    87,    88,    88,    88,
      88,    89,    89,    90,    90,    90,    90,    91,    91,    91,
      91,    91,    91,    92,    92,    92,    93,    93,    94,    94,
      95,    95,    96,    96,    97,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    98,    99,   100,   100,   101,   101,
     102,   102,   102,   102,   102,   102,   102,   102,   103,   103,
     104,   104,   105,   105,   106,   106,   107,   107,   108,   109,
     109,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   112,
     112,   113,   113,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   115,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   117,   117,   117,
     117,   117,   117,   118,   118,   118,   118,   118,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   120,   120,
     121,   121,   122,   122,   123,   123,   123,   123,   124,   124,
     124,   124,   124,   125,   126,   127,   127,   128,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   130,   130,
     130,   130
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     0,     9,     9,     8,
       8,     6,     5,     3,     2,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     2,     3,     2,     3,
       2,     1,     1,     3,     2,     1,     4,     5,     3,     2,
       1,     4,     5,     3,     2,     4,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     1,     1,
       2,     2,     2,     2,     2,     3,     2,     1,     2,     1,
       3,     2,     1,     3,     3,     5,     5,     3,     3,     9,
       9,     4,     7,     5,     9,     5,     7,     9,    11,     2,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       2,     1,     5,     2,     1,     1,     1,     1,     4,     1,
       1,     1,     1,     1,     3,     7,    33,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     2,     3,     3,
       3,     3,     3,     6,     6,     6,     6,     6,     4,     3,
       4,     3,     1,     3,     6,     5,     5,     4,     1,     1,
       1,     1,     1,     1,     3,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     8,
       6,     8
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,    50,    59,    51,    61,    65,    63,    52,
      67,    49,    48,    18,    19,    22,    21,    20,    17,     0,
       2,     4,     5,     0,     0,     0,     0,    31,    53,    54,
      55,    56,    57,    14,    16,    68,    58,    60,    64,    62,
      66,     1,     3,     0,     0,     0,    23,     0,     6,     6,
       0,     0,    30,     0,     0,     0,    25,    35,    40,    26,
      32,     0,     0,    13,    15,    27,     0,     0,     0,   171,
     169,   168,   172,   173,   174,   175,   176,   170,     0,   177,
       0,     0,     0,   102,   101,     0,     0,     0,     0,     0,
      82,    79,     0,     0,     0,    69,    77,     0,   100,     0,
       0,     0,     0,     0,     0,    24,     0,     0,    34,     0,
      39,     0,     0,     0,    14,     0,     0,     0,     0,     0,
      16,     0,     0,     0,   116,   117,   158,   159,   160,   161,
     162,     0,     0,     0,   167,   119,     0,     0,   111,   103,
       0,   123,   120,   121,   115,     0,   114,   122,     0,     0,
       0,     0,     0,     0,     0,     0,    81,     0,    78,    35,
      40,    28,    12,    70,    76,    99,    71,    72,    73,     0,
      74,     0,    44,    38,     0,    43,     0,    33,     0,     0,
       0,     0,   151,   152,     0,   138,   142,   141,   140,   139,
     149,     0,     0,    29,     0,     0,     0,   110,     0,   137,
       0,     0,   113,   127,   129,   132,   131,   130,   128,     0,
       0,     0,     0,     0,     0,    84,     0,     0,     0,     0,
      83,     0,    88,    87,     0,    75,     0,     0,     0,     0,
      80,     0,    11,    36,    41,     0,     0,     0,     0,   150,
       0,   148,     0,     0,   124,     0,   133,   108,   109,   107,
     105,   106,   104,     0,   134,     0,   136,   135,     0,   163,
       0,     0,     0,     0,     0,     0,    91,     0,     0,     0,
      37,    42,     0,     0,     0,     0,   153,     0,     0,     0,
       0,     0,   118,     0,    86,     0,    85,   157,     0,     0,
       0,     0,     0,     0,    93,     0,    95,     0,     0,   116,
     117,     0,     0,     9,     0,    10,     0,   143,   147,   146,
     145,   144,     0,   112,   165,     0,   156,     0,   155,     0,
       0,     0,     0,     0,     0,     0,   178,   180,     0,     0,
      46,     7,     8,     0,   164,   154,   166,     0,     0,     0,
      96,     0,    92,     0,     0,    45,     0,   125,     0,     0,
       0,     0,     0,     0,   179,   181,    47,     0,    90,    89,
      94,    97,     0,     0,     0,     0,    98,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   126
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    19,    20,    61,    21,    91,    23,    24,    45,    46,
      92,    93,    59,    60,   108,   270,   329,    26,   136,    28,
      29,    30,    31,    32,    36,    94,    95,    96,    97,    98,
     183,   138,   139,   216,   152,   141,   142,   143,   184,   144,
     145,   260,   290,   291,   146,   102,   147
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -117
static const short yypact[] =
{
    2208,   -34,   -32,  -117,   -24,  -117,   -24,   -24,   -24,  -117,
     -24,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  1067,
    -117,  -117,  -117,    21,   184,   203,   376,  -117,  -117,  -117,
    -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,
    -117,  -117,  -117,   502,    19,    18,  -117,   219,  -117,  -117,
       7,    52,  -117,   219,  1513,    61,   121,   -44,   -43,    62,
    -117,    72,    85,  -117,  -117,    62,   118,    33,   127,  -117,
    -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,   502,  -117,
    1777,  1777,   141,  -117,  -117,  1777,   146,   152,   159,  1025,
    -117,  -117,   156,   221,  1086,  -117,  -117,   160,   165,   162,
     163,   166,   171,   167,  1513,  -117,  1777,   -39,  -117,   -19,
    -117,   219,   110,   155,  1777,  1777,  1777,  1777,  1777,  1777,
    1777,  1777,   219,   174,   147,   169,  -117,  -117,  -117,  -117,
    -117,  1777,  1777,  1777,  -117,  -117,  1777,   888,  -117,  -117,
     966,  -117,  -117,  -117,  -117,   175,  -117,  -117,   888,   966,
    1777,   762,    50,  1777,  1777,  1552,  -117,  1147,  -117,   -33,
     -27,    62,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  1777,
    -117,  1208,  2262,  -117,   172,  -117,   173,  -117,   176,    67,
     179,   128,  -117,  2262,   -66,  2262,  2262,  2262,  2262,  2262,
    -117,    20,   112,    62,  1627,  1702,  1777,  -117,  2262,  -117,
     727,    15,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  1777,
    1777,  1777,  1777,  1777,  1777,   226,  1777,  1777,  1777,  1777,
     228,  1777,  -117,  -117,  2112,  -117,  1068,  1129,  1513,  1373,
    -117,  1434,  -117,   201,   201,  1513,   182,  1513,   185,  -117,
    1777,  -117,   -41,   466,  -117,  1777,  -117,   148,   148,    -4,
     194,   194,  -117,  1513,  2262,  2250,   207,  -117,  1513,  2262,
      -5,  1777,  1513,  1777,  1513,  1777,  -117,  1777,  1852,   189,
    -117,  -117,  1269,  1513,  1330,  1513,  2262,  1777,  1777,  1777,
    1777,  1777,   -41,  1614,  -117,  1777,  -117,  -117,  1777,  1777,
      30,    63,  2133,    -8,  -117,  1689,  -117,  1190,   948,     8,
      17,  1764,  1777,  -117,  1391,  -117,  1452,  2262,  2262,  2262,
    2262,  2262,  1777,  2262,  2262,  1539,  -117,   109,  -117,  1777,
    1777,  1777,  1777,  1513,  1777,  1513,  -117,  -117,   227,    77,
    2262,  -117,  -117,  1251,  -117,  -117,  2262,  2170,  2186,  2202,
    -117,  1312,  -117,   193,   195,  -117,  1777,  -117,  1777,  1513,
    1513,  1513,  1513,  1777,  -117,  -117,  2262,  1839,  -117,  -117,
    -117,  -117,  2218,  1777,  1513,  1870,  -117,  1777,  1892,  1777,
    1914,  1777,  1936,  1777,  1958,  1777,  1980,  1777,  2002,  1777,
    2024,  1777,  2046,  1777,  2068,  1777,  2090,  1777,  2234,  -117
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -117,  -117,   250,   222,  -117,     3,  -117,  -117,   126,   220,
    -117,     2,   -47,   168,   -57,    44,  -117,  -117,     0,  -117,
    -117,  -117,  -117,  -117,   204,   -84,   582,  -117,  -117,  -117,
     497,  -117,  -117,  -117,   -64,    56,   140,   196,  -116,  -117,
    -117,  -117,  -117,    -9,    -7,  -117,   336
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      27,   110,    25,    22,   191,   157,    65,   106,   106,   239,
     277,   278,   279,   280,   281,   240,   140,   149,   106,    27,
     171,    25,    22,    27,   106,    47,    52,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,   134,   107,   109,
      33,    63,    34,    27,   173,    53,   161,    64,   217,   107,
     218,   219,    43,    35,    27,   109,    27,   134,    47,   115,
     116,   117,   118,   119,   175,   212,   213,   214,   199,   201,
     287,   217,   321,   218,   219,   193,   288,   289,    27,   191,
     122,    63,   195,   326,   115,   116,   117,   118,   119,    27,
     246,   165,   327,    55,    27,   241,    44,    54,    56,   196,
     174,   240,   176,   110,    27,   316,   217,   120,   218,   219,
      99,   288,    27,    27,    47,    47,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    64,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    27,   318,   104,
      27,    43,   236,   111,   319,    99,   112,    56,    27,    27,
      99,   272,    43,   274,   256,   257,   345,    27,   346,   113,
      99,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    27,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   335,   178,    43,    48,    49,   304,
     319,   306,   114,    99,   100,   242,    99,   293,   115,   116,
     117,   118,   119,   238,    99,    99,    50,    51,    56,   121,
      37,    38,    39,    99,    40,   150,   211,   212,   213,   214,
     153,   195,    57,    58,   159,   160,   154,    99,    27,   100,
     180,   343,   344,   155,   100,    27,   158,    27,   179,   181,
     164,   134,   166,   167,   100,   169,   168,   170,   194,   221,
     101,   196,   269,    27,   235,   233,   234,   237,    27,   253,
     273,   258,    27,   275,    27,   214,   219,   302,   354,    42,
     355,    62,    27,    27,    27,    27,   105,   100,   271,   177,
     100,   317,     0,     0,    99,   101,     0,     0,   100,   100,
     101,    99,     0,    99,     0,     0,     0,   100,     0,     0,
     101,     0,     0,     0,    27,     0,    27,     0,     0,    99,
       0,   100,     0,     0,    99,     0,     0,     0,    99,     0,
      99,     0,     0,    27,     0,    27,     0,     0,    99,    99,
      99,    99,     0,   101,     0,     0,   101,     0,     0,     0,
       0,     0,     0,     0,   101,   101,     0,     0,     0,    27,
      27,    27,    27,   101,     0,     0,     0,     0,     0,     0,
      99,     0,    99,     0,    27,     0,     0,   101,   100,     0,
       0,     0,     0,     0,     0,   100,     0,   100,     0,    99,
       0,    99,     3,     4,     5,     6,     7,     8,     9,    10,
     103,     0,     0,   100,     0,     0,     0,     0,   100,     0,
       0,     0,   100,     0,   100,    99,    99,    99,    99,     0,
       0,     0,   100,   100,   100,   100,     0,     0,     0,     0,
      99,     0,     0,     0,   101,   103,     0,     0,     0,     0,
     103,   101,     0,   101,     0,     0,     0,     0,     0,     0,
     103,     0,     0,     0,   100,     0,   100,     0,     0,   101,
       0,     0,     0,     0,   101,     0,     0,     0,   101,     0,
     101,     0,     0,   100,     0,   100,     0,     0,   101,   101,
     101,   101,     0,   103,     0,     0,   103,     0,     0,     0,
       0,     0,     0,     0,   103,   103,     0,     0,     0,   100,
     100,   100,   100,   103,     0,     0,     0,     0,     0,     0,
     101,     0,   101,     0,   100,     0,     0,   103,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,     0,   101,
       0,   101,     0,     0,     0,     0,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,   101,   101,   101,   101,   282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     101,     0,     0,     0,   103,     0,     0,     0,     0,     0,
       0,   103,     0,   103,     0,     0,     0,   137,   148,     0,
       0,     0,   151,     0,     0,     0,     0,     0,     0,   103,
       0,     0,     0,     0,   103,     0,     0,     0,   103,     0,
     103,     0,     0,   172,     0,     0,     0,     0,   103,   103,
     103,   103,   185,   186,   187,   188,   189,     0,   192,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   197,   198,
     200,     0,     0,   202,     0,     0,     0,     0,     0,     0,
     103,     0,   103,     0,     0,     0,     0,   224,     0,     0,
     226,   227,   229,     0,     0,     0,     0,     0,     0,   103,
       0,   103,     0,     0,     0,     0,   231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   163,     0,     0,     0,
       0,     0,     0,     0,     0,   103,   103,   103,   103,     0,
       0,     0,     0,   243,     0,     0,     0,     0,     0,     0,
     103,     0,     0,     0,     0,     0,   247,   248,   249,   250,
     251,   252,     0,   254,   255,   198,   198,     0,   259,   215,
       0,     0,   220,     0,     0,     0,     0,     0,     0,     0,
     222,   223,     0,     0,     0,     0,     0,   276,     0,   163,
       0,     0,   283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   163,     0,     0,     0,     0,   292,     0,
     295,     0,   297,     0,   298,   301,     0,     0,     0,     0,
       0,     0,     0,     0,   307,   308,   309,   310,   311,     0,
       0,     0,   313,     0,     0,   314,   315,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   330,
       0,     0,   244,     0,     0,     0,     0,     0,   245,   333,
     266,     0,     0,     0,     0,     0,   336,   337,   338,   339,
       0,   341,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,   284,     0,     0,     0,     0,
     286,     0,   225,   356,   294,   357,   296,     0,     0,     0,
     362,     0,     0,     0,   163,     0,   163,     0,     0,     0,
     365,     0,     0,     0,   368,     0,   370,     0,   372,     0,
     374,     0,   376,     0,   378,     0,   380,     0,   382,     0,
     384,     0,   386,     0,   388,     0,   163,     0,   163,     0,
       0,    66,    67,    68,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    69,   340,     0,   342,    70,     0,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,     0,    81,    82,    83,    84,    85,    86,    87,    88,
       0,   358,   359,   360,   361,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   366,     0,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,     0,     0,     0,    89,     0,    90,    66,
      67,    68,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    69,     0,     0,     0,    70,     0,    71,    72,
      73,    74,    75,    76,    77,    78,    79,     0,    80,     0,
      81,    82,    83,    84,    85,    86,    87,    88,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,   217,   325,   218,   219,     0,     0,    66,    67,
      68,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    69,     0,     0,    89,    70,    90,    71,    72,    73,
      74,    75,    76,    77,    78,    79,     0,    80,     0,    81,
      82,    83,    84,    85,    86,    87,    88,    41,     0,     0,
       1,     2,     0,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    66,
      67,    68,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    69,    89,   156,    90,    70,     0,    71,    72,
      73,    74,    75,    76,    77,    78,    79,     0,    80,     0,
      81,    82,    83,    84,    85,    86,    87,    88,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,   262,     0,     0,     0,     0,     0,   263,
      66,    67,    68,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    69,    89,   162,    90,    70,     0,    71,
      72,    73,    74,    75,    76,    77,    78,    79,     0,    80,
       0,    81,    82,    83,    84,    85,    86,    87,    88,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,   264,     0,     0,     0,     0,     0,
     265,    66,    67,    68,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    69,    89,   230,    90,    70,     0,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,     0,    81,    82,    83,    84,    85,    86,    87,    88,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,   323,     0,     0,     0,     0,
       0,   324,    66,    67,    68,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    69,    89,   232,    90,    70,
       0,    71,    72,    73,    74,    75,    76,    77,    78,    79,
       0,    80,     0,    81,    82,    83,    84,    85,    86,    87,
      88,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,     0,     0,     0,   347,     0,     0,     0,
       0,     0,   348,    66,    67,    68,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    69,    89,   303,    90,
      70,     0,    71,    72,    73,    74,    75,    76,    77,    78,
      79,     0,    80,     0,    81,    82,    83,    84,    85,    86,
      87,    88,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,   352,     0,     0,
       0,     0,     0,   353,    66,    67,    68,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    69,    89,   305,
      90,    70,     0,    71,    72,    73,    74,    75,    76,    77,
      78,    79,     0,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   267,    66,    67,    68,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    69,    89,
     331,    90,    70,     0,    71,    72,    73,    74,    75,    76,
      77,    78,    79,     0,    80,     0,    81,    82,    83,    84,
      85,    86,    87,    88,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   268,    66,    67,    68,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    69,
      89,   332,    90,    70,     0,    71,    72,    73,    74,    75,
      76,    77,    78,    79,     0,    80,     0,    81,    82,    83,
      84,    85,    86,    87,    88,   123,   124,   125,     3,     4,
       5,     6,     7,     8,     9,    10,     0,     0,    69,     0,
       0,     0,    70,     0,    71,    72,    73,    74,    75,    76,
      77,     0,    79,     0,     0,     0,     0,     0,     0,     0,
       0,    89,     0,    90,   126,   127,   128,   129,   130,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,     0,     0,     0,     0,     0,   131,
       0,     0,   334,     0,   132,     0,   133,   228,   134,   135,
     123,   124,   125,     3,     4,     5,     6,     7,     8,     9,
      10,     0,     0,    69,     0,     0,     0,    70,     0,    71,
      72,    73,    74,    75,    76,    77,     0,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,   130,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,   131,   312,     0,     0,     0,   132,
       0,   133,   182,   134,   135,   123,   124,   125,     3,     4,
       5,     6,     7,     8,     9,    10,     0,     0,    69,     0,
       0,     0,    70,     0,    71,    72,    73,    74,    75,    76,
      77,     0,    79,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,   130,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,     0,     0,     0,     0,     0,   131,
     322,     0,     0,     0,   132,     0,   133,   190,   134,   135,
     123,   124,   125,     3,     4,     5,     6,     7,     8,     9,
      10,     0,     0,    69,     0,     0,     0,    70,     0,    71,
      72,    73,    74,    75,    76,    77,     0,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,   130,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,   131,   328,     0,     0,     0,   132,
       0,   133,     0,   134,   135,   123,   299,   300,     3,     4,
       5,     6,     7,     8,     9,    10,     0,     0,    69,     0,
       0,     0,    70,     0,    71,    72,    73,    74,    75,    76,
      77,     0,    79,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,   130,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,     0,     0,     0,     0,     0,   131,
     363,     0,     0,     0,   132,     0,   133,     0,   134,   135,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   367,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   369,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   371,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   373,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   375,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   377,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   379,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   381,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   383,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   385,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   387,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,     0,   261,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,     0,     0,     0,     0,     0,
       0,     1,     2,   320,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,   349,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,   350,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,   351,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,   364,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   285,     0,   389,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214
};

static const short yycheck[] =
{
       0,    58,     0,     0,   120,    89,    53,    51,    51,    75,
      51,    52,    53,    54,    55,    81,    80,    81,    51,    19,
     104,    19,    19,    23,    51,    23,    26,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    76,    82,    82,
      74,    74,    74,    43,    83,    43,    93,    74,    56,    82,
      58,    59,    31,    77,    54,    82,    56,    76,    56,    51,
      52,    53,    54,    55,    83,    69,    70,    71,   132,   133,
      75,    56,    80,    58,    59,   122,    81,    82,    78,   195,
      78,    74,    74,    75,    51,    52,    53,    54,    55,    89,
      75,    98,    75,    75,    94,    75,    75,    78,    80,    82,
     107,    81,   109,   160,   104,    75,    56,    74,    58,    59,
      54,    81,   112,   113,   112,   113,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    74,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,   137,    75,    78,
     140,    31,    75,    81,    81,    89,    74,    80,   148,   149,
      94,   235,    31,   237,   218,   219,    79,   157,    81,    74,
     104,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,   171,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    75,    75,    31,     3,     4,   273,
      81,   275,    74,   137,    54,    83,   140,   261,    51,    52,
      53,    54,    55,    75,   148,   149,     3,     4,    80,    82,
       6,     7,     8,   157,    10,    74,    68,    69,    70,    71,
      74,    74,     3,     4,     3,     4,    74,   171,   228,    89,
      75,     4,     5,    74,    94,   235,    80,   237,   112,   113,
      80,    76,    80,    80,   104,    74,    80,    80,    74,    74,
      54,    82,    51,   253,    78,    83,    83,    78,   258,    33,
      78,    33,   262,    78,   264,    71,    59,    78,    75,    19,
      75,    49,   272,   273,   274,   275,    56,   137,   234,   111,
     140,   290,    -1,    -1,   228,    89,    -1,    -1,   148,   149,
      94,   235,    -1,   237,    -1,    -1,    -1,   157,    -1,    -1,
     104,    -1,    -1,    -1,   304,    -1,   306,    -1,    -1,   253,
      -1,   171,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,
     264,    -1,    -1,   323,    -1,   325,    -1,    -1,   272,   273,
     274,   275,    -1,   137,    -1,    -1,   140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,    -1,    -1,    -1,   349,
     350,   351,   352,   157,    -1,    -1,    -1,    -1,    -1,    -1,
     304,    -1,   306,    -1,   364,    -1,    -1,   171,   228,    -1,
      -1,    -1,    -1,    -1,    -1,   235,    -1,   237,    -1,   323,
      -1,   325,     6,     7,     8,     9,    10,    11,    12,    13,
      54,    -1,    -1,   253,    -1,    -1,    -1,    -1,   258,    -1,
      -1,    -1,   262,    -1,   264,   349,   350,   351,   352,    -1,
      -1,    -1,   272,   273,   274,   275,    -1,    -1,    -1,    -1,
     364,    -1,    -1,    -1,   228,    89,    -1,    -1,    -1,    -1,
      94,   235,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,    -1,   304,    -1,   306,    -1,    -1,   253,
      -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,
     264,    -1,    -1,   323,    -1,   325,    -1,    -1,   272,   273,
     274,   275,    -1,   137,    -1,    -1,   140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,    -1,    -1,    -1,   349,
     350,   351,   352,   157,    -1,    -1,    -1,    -1,    -1,    -1,
     304,    -1,   306,    -1,   364,    -1,    -1,   171,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,   323,
      -1,   325,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   349,   350,   351,   352,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     364,    -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,   237,    -1,    -1,    -1,    80,    81,    -1,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,
     264,    -1,    -1,   106,    -1,    -1,    -1,    -1,   272,   273,
     274,   275,   115,   116,   117,   118,   119,    -1,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,   132,
     133,    -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,
     304,    -1,   306,    -1,    -1,    -1,    -1,   150,    -1,    -1,
     153,   154,   155,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,   325,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
     364,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,   218,   219,    -1,   221,   137,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,    -1,    -1,    -1,    -1,    -1,   240,    -1,   157,
      -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,   261,    -1,
     263,    -1,   265,    -1,   267,   268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,   279,   280,   281,    -1,
      -1,    -1,   285,    -1,    -1,   288,   289,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,   302,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,   312,
     228,    -1,    -1,    -1,    -1,    -1,   319,   320,   321,   322,
      -1,   324,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,   253,    -1,    -1,    -1,    -1,
     258,    -1,    80,   346,   262,   348,   264,    -1,    -1,    -1,
     353,    -1,    -1,    -1,   272,    -1,   274,    -1,    -1,    -1,
     363,    -1,    -1,    -1,   367,    -1,   369,    -1,   371,    -1,
     373,    -1,   375,    -1,   377,    -1,   379,    -1,   381,    -1,
     383,    -1,   385,    -1,   387,    -1,   304,    -1,   306,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,   323,    -1,   325,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    -1,    34,    35,    36,    37,    38,    39,    40,    41,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   364,    -1,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    80,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    -1,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    56,    75,    58,    59,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    78,    20,    80,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    41,     0,    -1,    -1,
       3,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    78,    79,    80,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    78,    79,    80,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      -1,    34,    35,    36,    37,    38,    39,    40,    41,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    78,    79,    80,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    -1,    34,    35,    36,    37,    38,    39,    40,    41,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,
      -1,    81,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    78,    79,    80,    20,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    -1,    34,    35,    36,    37,    38,    39,    40,
      41,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    78,    79,    80,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    81,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    78,    79,
      80,    20,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    78,
      79,    80,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      78,    79,    80,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    -1,    34,    35,    36,
      37,    38,    39,    40,    41,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    16,    -1,
      -1,    -1,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    80,    42,    43,    44,    45,    46,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    83,    -1,    72,    -1,    74,    75,    76,    77,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    16,    -1,    -1,    -1,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    45,    46,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    81,    -1,    -1,    -1,    72,
      -1,    74,    75,    76,    77,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    16,    -1,
      -1,    -1,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      81,    -1,    -1,    -1,    72,    -1,    74,    75,    76,    77,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    16,    -1,    -1,    -1,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    45,    46,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    81,    -1,    -1,    -1,    72,
      -1,    74,    -1,    76,    77,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    16,    -1,
      -1,    -1,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      81,    -1,    -1,    -1,    72,    -1,    74,    -1,    76,    77,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,    80,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    75,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    75,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    75,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    75,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    57,    -1,    75,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    85,
      86,    88,    89,    90,    91,    95,   101,   102,   103,   104,
     105,   106,   107,    74,    74,    77,   108,   108,   108,   108,
     108,     0,    86,    31,    75,    92,    93,    95,     3,     4,
       3,     4,   102,    95,    78,    75,    80,     3,     4,    96,
      97,    87,    87,    74,    74,    96,     3,     4,     5,    16,
      20,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      32,    34,    35,    36,    37,    38,    39,    40,    41,    78,
      80,    89,    94,    95,   109,   110,   111,   112,   113,   119,
     120,   121,   129,   130,    78,    93,    51,    82,    98,    82,
      98,    81,    74,    74,    74,    51,    52,    53,    54,    55,
      74,    82,    95,     3,     4,     5,    42,    43,    44,    45,
      46,    67,    72,    74,    76,    77,   102,   114,   115,   116,
     118,   119,   120,   121,   123,   124,   128,   130,   114,   118,
      74,   114,   118,    74,    74,    74,    79,   109,    80,     3,
       4,    96,    79,   110,    80,   128,    80,    80,    80,    74,
      80,   109,   114,    83,   128,    83,   128,    97,    75,    92,
      75,    92,    75,   114,   122,   114,   114,   114,   114,   114,
      75,   122,   114,    96,    74,    74,    82,   114,   114,   118,
     114,   118,   114,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,   110,   117,    56,    58,    59,
     110,    74,   110,   110,   114,    80,   114,   114,    75,   114,
      79,   114,    79,    83,    83,    78,    75,    78,    75,    75,
      81,    75,    83,   114,    75,    81,    75,   114,   114,   114,
     114,   114,   114,    33,   114,   114,   118,   118,    33,   114,
     125,    80,    75,    81,    75,    81,   110,    81,    81,    51,
      99,    99,   109,    78,   109,    78,   114,    51,    52,    53,
      54,    55,    83,   114,   110,    57,   110,    75,    81,    82,
     126,   127,   114,   118,   110,   114,   110,   114,   114,     4,
       5,   114,    78,    79,   109,    79,   109,   114,   114,   114,
     114,   114,    81,   114,   114,   114,    75,   127,    75,    81,
      80,    80,    81,    75,    81,    75,    75,    75,    81,   100,
     114,    79,    79,   114,    83,    75,   114,   114,   114,   114,
     110,   114,   110,     4,     5,    79,    81,    75,    81,    75,
      75,    75,    75,    81,    75,    75,   114,   114,   110,   110,
     110,   110,   114,    81,    75,   114,   110,    81,   114,    81,
     114,    81,   114,    81,   114,    81,   114,    81,   114,    81,
     114,    81,   114,    81,   114,    81,   114,    81,   114,    75
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 169 "parser.yxx"
    {ParseTreePointer=yyvsp[0].m_pParseNode;}
    break;

  case 3:
#line 171 "parser.yxx"
    {ParseTreePointer->AddLastChild(yyvsp[0].m_pParseNode);}
    break;

  case 6:
#line 181 "parser.yxx"
    {
			yyval.m_Pos.m_LineNo = ParseLineNumber;
			yyval.m_Pos.m_strFileName = ParseStreamName.c_str();
		}
    break;

  case 7:
#line 189 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-7].m_Identifier->c_str(),yyvsp[-8].m_ShaderType);
								yyval.m_pParseNode->SetPos(yyvsp[-6].m_Pos);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;

  case 8:
#line 202 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-7].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-7].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-7].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-8].m_ShaderType);
								yyval.m_pParseNode->SetPos(yyvsp[-6].m_Pos);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;

  case 9:
#line 218 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-6].m_Identifier->c_str(), yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(yyvsp[-5].m_Pos);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 10:
#line 225 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-6].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-6].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-6].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(yyvsp[-5].m_Pos);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 11:
#line 238 "parser.yxx"
    {
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-5].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");
								
								// Make a string of the parameter types.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									// Each child of the variable_definitions is a CqParseNodeVariable
									CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());
									while(pVar)
									{
										// If storage is not specified, a function parameter defaults to varying.
										pVar->SetDefaultStorage(Type_Varying);
										// Get the type from the variable
										strArgTypes+=CqParseNode::TypeIdentifier(pVar->ResType());
										// TODO: Find out if local function arguments can have default values.
										// If so, they can be found as the child of pVar.
										pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
									}
								}

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), strArgTypes.c_str(), yyvsp[-1].m_pParseNode, pArgs);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;

  case 12:
#line 277 "parser.yxx"
    {
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-4].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), "", yyvsp[-1].m_pParseNode, 0);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;

  case 13:
#line 299 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 14:
#line 307 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 15:
#line 315 "parser.yxx"
    {
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 16:
#line 328 "parser.yxx"
    {	
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 17:
#line 344 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Lightsource;
							}
    break;

  case 18:
#line 347 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Surface;
							}
    break;

  case 19:
#line 350 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Volume;
							}
    break;

  case 20:
#line 353 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Displacement;
							}
    break;

  case 21:
#line 356 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Transformation;
							}
    break;

  case 22:
#line 359 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Imager;
							}
    break;

  case 23:
#line 366 "parser.yxx"
    {
								// Create a list header, and add the first entry to it.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;

  case 24:
#line 379 "parser.yxx"
    {
								// Add this one to the list.
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;

  case 26:
#line 394 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 27:
#line 465 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNodeVariable* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetOutput();
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 28:
#line 541 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
										{
											Type=(TqInt)(Type|Type_Array);
											if( pVar->ArrayLength() <= 0 )
												yyerror("Array length must be specified.");
										}

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 29:
#line 616 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									SqVarRef varLocal, varExtern;
									TqBool fvl=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), varLocal);

									// As this is an extern, we need to repeatedly check in the previous namespaces
									// until we find the variable they are referring to.
									TqBool fve=TqFalse;
									if(!ParseNameSpaceStack.empty())
									{
										std::vector<CqString>::reverse_iterator i=ParseNameSpaceStack.rbegin()+1;
										while(!fve && i!=ParseNameSpaceStack.rend())
										{
											CqString strNS=*i;
											fve=CqVarDef::FindVariable((strNS+pDecl->strName()).c_str(), varExtern);
											i++;
										}
									}
									if(!fve)
									{
										// If not found in the namespaces defined in the code, check the global namespace.
										fve=CqVarDef::FindStandardVariable(pDecl->strName(), varExtern);
									}

									// If we found a candidate...
									if(fve && fvl)
									{
										CqVarDef* pvarLocal=CqVarDef::GetVariablePtr(varLocal);
										CqVarDef* pvarExtern=CqVarDef::GetVariablePtr(varExtern);
										CqParseNode* pVarNode=new CqParseNodeVariable(varLocal);
										pvarLocal->SetExtern(TqTrue, varExtern);
										pvarLocal->SetType(pvarExtern->Type());
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);
									}
									else
										yyerror("extern not found");

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 30:
#line 666 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=(TqInt)(yyvsp[0].m_TypeAndSpace.Type|yyvsp[-1].m_VarType);
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_TypeAndSpace.Space;
							}
    break;

  case 32:
#line 674 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 33:
#line 681 "parser.yxx"
    {
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 34:
#line 688 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-1].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[-1].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 35:
#line 697 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[0].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 36:
#line 704 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-3].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-3].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 37:
#line 712 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-4].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-4].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 38:
#line 720 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-2].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-2].m_Identifier).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 39:
#line 727 "parser.yxx"
    {
								// Create a new declaration based on the name.
								// TODO: Should warn about duplicate declarations.
								CqString strName("");
								if(yyvsp[-1].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 40:
#line 741 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[0].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[0].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[0].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 41:
#line 751 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-3].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-3].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 42:
#line 762 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-4].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-4].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-4].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 43:
#line 773 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-2].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-2].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 44:
#line 786 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;
							}
    break;

  case 45:
#line 793 "parser.yxx"
    {
								CqParseNode* pArrayInit=new CqParseNode();
								CqParseNode* pInit=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pInit)
								{
									CqParseNode* pInit2=pInit->pNext();
									pArrayInit->AddLastChild(pInit);
									pInit=pInit2;
								}
								yyval.m_pParseNode=pArrayInit;
							}
    break;

  case 46:
#line 807 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 47:
#line 814 "parser.yxx"
    {
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 48:
#line 821 "parser.yxx"
    {	yyval.m_VarType=Type_Varying;	}
    break;

  case 49:
#line 822 "parser.yxx"
    {	yyval.m_VarType=Type_Uniform;	}
    break;

  case 50:
#line 826 "parser.yxx"
    {	
								yyval.m_TypeAndSpace.Type=Type_Float;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 51:
#line 830 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_String;	
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 52:
#line 834 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Void;
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 58:
#line 846 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 59:
#line 850 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 60:
#line 857 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 61:
#line 861 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 62:
#line 868 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 63:
#line 872 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 64:
#line 879 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 65:
#line 883 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 66:
#line 890 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 67:
#line 894 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 69:
#line 905 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 70:
#line 912 "parser.yxx"
    {
								// Add this one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 71:
#line 919 "parser.yxx"
    {yyval.m_pParseNode->NoDup();}
    break;

  case 72:
#line 920 "parser.yxx"
    {
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;

  case 73:
#line 928 "parser.yxx"
    {
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;

  case 74:
#line 936 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeDrop();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 75:
#line 942 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								// Increment the count of returns for the current function.
								if(FunctionReturnCountStack.size() > 0)
									FunctionReturnCountStack.back()++;
							}
    break;

  case 78:
#line 953 "parser.yxx"
    {
								// Remove the variable nodes from these leaving just the 
								// intialisation code.
								// Each child of the variable_definitions is a CqParseNodeVariable
								CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(yyvsp[-1].m_pParseNode->pFirstChild());
								while(pVar)
								{
									CqParseNodeVariable* pTemp=static_cast<CqParseNodeVariable*>(pVar->pNext());

									// If storage is not specified, local variable defaults to varying.
									pVar->SetDefaultStorage(Type_Varying);
									
									// Relink the initialisers, if any, after the variable.
									if(pVar->pFirstChild())
									{
										// Make sure that any change in the storage type is communicated to the initialiser
										pVar->pFirstChild()->UpdateStorageStatus();
										CqParseNode* pVarying=pVar->pFirstChild();
										pVarying->LinkAfter(pVar);
									}
									pVar->UnLink();
									delete(pVar);
									pVar=pTemp;
								}
							}
    break;

  case 80:
#line 979 "parser.yxx"
    {	yyval.m_pParseNode=yyvsp[-1].m_pParseNode;	}
    break;

  case 81:
#line 980 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNode(); }
    break;

  case 82:
#line 981 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNode(); }
    break;

  case 83:
#line 983 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-1].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 84:
#line 990 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-1].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);

								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(relation);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;

							}
    break;

  case 85:
#line 1005 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-3].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 86:
#line 1013 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-3].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);
								CqParseNode* pNew=new CqParseNodeConditional();
								
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(relation);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 87:
#line 1032 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 88:
#line 1038 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-1].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);
								CqParseNode* pNew=new CqParseNodeConditional();

								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(relation);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 89:
#line 1052 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(yyvsp[-4].m_pParseNode);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 90:
#line 1067 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-4].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);

								CqParseNode* pNew=new CqParseNodeConditional();
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(relation);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 91:
#line 1089 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeSolarConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 92:
#line 1095 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeSolarConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 93:
#line 1109 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 94:
#line 1118 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 95:
#line 1134 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 96:
#line 1147 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 97:
#line 1161 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 98:
#line 1178 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-8].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-8].m_pParseNode->NoDup();
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 101:
#line 1203 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 102:
#line 1207 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 104:
#line 1217 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator.", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 105:
#line 1228 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 106:
#line 1239 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 107:
#line 1250 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator^", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 108:
#line 1261 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 109:
#line 1272 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 110:
#line 1283 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operatorneg", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddFirstChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 112:
#line 1294 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeQCond();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-4].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 113:
#line 1306 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pCast=new CqParseNodeCast(yyvsp[-1].m_TypeAndSpace.Type);
								pCast->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pCast->AddFirstChild(yyvsp[0].m_pParseNode);
								
								TqInt Type=(TqInt)(yyvsp[-1].m_TypeAndSpace.Type&Type_Mask);
								CqString* pSpace=yyvsp[-1].m_TypeAndSpace.Space;
								// Check if the type has a valid space associated
								if(pSpace!=0 && pSpace->compare("")!=0 && 
								  ((Type==Type_Point) ||
								   (Type==Type_Normal) ||
								   (Type==Type_Vector) ||
								   (Type==Type_Matrix) ||
								   (Type==Type_Color) ))
								{
									// Create a transform function.
									std::vector<SqFuncRef> funcTrans;
									CqString strTrans("transform");;
									if(Type==Type_Normal)	strTrans="ntransform";
									else if(Type==Type_Vector)	strTrans="vtransform";
									else if(Type==Type_Matrix)	strTrans="mtransform";
									else if(Type==Type_Color)	strTrans="ctransform";
									if(FindFunction(strTrans.c_str(), funcTrans))
									{
										yyval.m_pParseNode=new CqParseNodeFunctionCall(funcTrans);
										yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									
										// And create a holder for the arguments.
										CqParseNode* pFromSpace=new CqParseNodeStringConst((*yyvsp[-1].m_TypeAndSpace.Space).c_str());
										CqParseNode* pToSpace;
										if(Type != Type_Color)	pToSpace = new CqParseNodeStringConst("current");
										else					pToSpace = new CqParseNodeStringConst("rgb");
										yyval.m_pParseNode->AddLastChild(pFromSpace);
										yyval.m_pParseNode->AddLastChild(pToSpace);
										yyval.m_pParseNode->AddLastChild(pCast);
									}
								}
								else
									yyval.m_pParseNode->AddFirstChild(pCast);
							}
    break;

  case 114:
#line 1352 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNodeFloatConst(yyvsp[0].m_FloatConst);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 116:
#line 1357 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 117:
#line 1361 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariableArray(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 118:
#line 1365 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariableArray(yyvsp[-3].m_pSymbol.VarRef);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 119:
#line 1370 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 124:
#line 1378 "parser.yxx"
    {	
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;

  case 125:
#line 1382 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeTriple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 126:
#line 1390 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeHexTuple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-31].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-29].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-27].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-25].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-23].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-21].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-19].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-17].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-15].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-13].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-11].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-9].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-7].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 127:
#line 1413 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_G);	}
    break;

  case 128:
#line 1414 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_GE);	}
    break;

  case 129:
#line 1415 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_L);	}
    break;

  case 130:
#line 1416 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_LE);	}
    break;

  case 131:
#line 1417 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_EQ);	}
    break;

  case 132:
#line 1418 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_NE);	}
    break;

  case 133:
#line 1422 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;

  case 134:
#line 1426 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 135:
#line 1433 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogAnd);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 136:
#line 1440 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogOr);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 137:
#line 1446 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeUnaryOp(Op_LogicalNot);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 138:
#line 1455 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 139:
#line 1461 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 140:
#line 1475 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 141:
#line 1489 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 142:
#line 1503 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 143:
#line 1517 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 144:
#line 1524 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 145:
#line 1542 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 146:
#line 1560 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 147:
#line 1578 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 148:
#line 1599 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 149:
#line 1608 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 150:
#line 1620 "parser.yxx"
    {
								std::cerr << warning << "Unresolved function " << yyvsp[-3].m_Identifier->c_str() << " will be treated as a DSO at runtime" << std::endl;
								CqParseNode* pArgs=yyvsp[-1].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									CqParseNode* pArg=static_cast<CqParseNode*>(pArgs->pFirstChild());
									while(pArg)
									{
										strArgTypes+=CqParseNode::TypeIdentifier(pArg->ResType());
										pArg=static_cast<CqParseNode*>(pArg->pNext());
									}
								};

								CqFuncDef func_spec(Type_Nil,yyvsp[-3].m_Identifier->c_str(),"unresolved",strArgTypes.c_str(), (CqParseNode*)NULL, pArgs);
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pUFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pUFunc;
							}
    break;

  case 151:
#line 1642 "parser.yxx"
    {
								// Need to emit a warning.
								// This should in theory be the eaiest case to handle
								// since there are no arguments that might need casting
								// later.
								std::cerr << warning << "Unresolved function " << yyvsp[-2].m_Identifier->c_str() << " will be treated as a DSO at runtime" << std::endl;
								CqFuncDef func_spec(Type_Nil, yyvsp[-2].m_Identifier->c_str(), "unresolved","");
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pUFunc;
							}
    break;

  case 152:
#line 1657 "parser.yxx"
    {
								// Create a list header, and add the first entry.
									yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 153:
#line 1664 "parser.yxx"
    {
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 154:
#line 1672 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;

  case 155:
#line 1686 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;

  case 156:
#line 1700 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 157:
#line 1706 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
							}
    break;

  case 158:
#line 1714 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("texture", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 159:
#line 1720 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("environment", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 160:
#line 1726 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("bump", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 161:
#line 1732 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("shadow", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 162:
#line 1738 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("occlusion", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 163:
#line 1747 "parser.yxx"
    {	
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 164:
#line 1754 "parser.yxx"
    {	yyval.m_pParseNode=yyvsp[-1].m_pParseNode; }
    break;

  case 165:
#line 1758 "parser.yxx"
    {
								// Create a list header and add the first entry.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 166:
#line 1765 "parser.yxx"
    {
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 168:
#line 1778 "parser.yxx"
    {yyval.m_CommType=CommTypeAtmosphere;}
    break;

  case 169:
#line 1779 "parser.yxx"
    {yyval.m_CommType=CommTypeDisplacement;}
    break;

  case 170:
#line 1780 "parser.yxx"
    {yyval.m_CommType=CommTypeLightsource;}
    break;

  case 171:
#line 1781 "parser.yxx"
    {yyval.m_CommType=CommTypeSurface;}
    break;

  case 172:
#line 1782 "parser.yxx"
    {yyval.m_CommType=CommTypeAttribute;}
    break;

  case 173:
#line 1783 "parser.yxx"
    {yyval.m_CommType=CommTypeOption;}
    break;

  case 174:
#line 1784 "parser.yxx"
    {yyval.m_CommType=CommTypeRendererInfo;}
    break;

  case 175:
#line 1785 "parser.yxx"
    {yyval.m_CommType=CommTypeIncident;}
    break;

  case 176:
#line 1786 "parser.yxx"
    {yyval.m_CommType=CommTypeOpposite;}
    break;

  case 177:
#line 1787 "parser.yxx"
    {yyval.m_CommType=CommTypeTextureInfo;}
    break;

  case 178:
#line 1793 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 179:
#line 1815 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 180:
#line 1844 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 181:
#line 1866 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;


    }

/* Line 999 of yacc.c.  */
#line 4034 "parser.cxx"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1897 "parser.yxx"


namespace Aqsis
{

TqBool FindVariable(const char* name, SqVarRef& Ref)
{
	// First search in the current namespace, then in the global namespace.
	CqString strLocalVar(strNameSpace()+name);
	
	if(CqVarDef::FindVariable(strLocalVar.c_str(), Ref))	return(TqTrue);
	else	return(CqVarDef::FindVariable(name, Ref));

	
}


TqBool FindFunction(const char* name, std::vector<SqFuncRef>& Ref)
{
	// Search in the namespaces from local to global in order.
	CqString strNS(strNameSpace());
	
	do
	{
		CqString strLocalFunc(strNS+name);
		if(CqFuncDef::FindFunction(strLocalFunc.c_str(), Ref))
			return(TqTrue);

		// Extract the next namespace up.
		if( ( strNS.size() > 2 ) && ( strNS.substr( strNS.size()-2 ) == "::" ) )
		{
			strNS = strNS.substr( 0, strNS.size()-2 );
			strNS = strNS.substr(0, strNS.rfind("::")+strlen("::"));
		}

	}while( strNS.find_last_of("::") != std::string::npos );
	
	return(CqFuncDef::FindFunction(name, Ref));
}


void TypeCheck()
{
	// Typecheck any declared variables.
	TqUint i;
	for(i=0; i<gLocalVars.size(); i++)
	{
		TqBool needsCast = TqFalse;
		if(gLocalVars[i].pDefValue()!=0)
			gLocalVars[i].pDefValue()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1, needsCast, TqFalse);
	}

	// Typecheck any local functions.
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
		{
			TqBool needsCast = TqFalse;
//			TqInt RetType=gLocalFuncs[i].Type();
			gLocalFuncs[i].pDefNode()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1, needsCast, TqFalse);
		}
	}

	TqBool needsCast = TqFalse;
	if(ParseTreePointer)
		ParseTreePointer->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1, needsCast, TqFalse);
}


void Optimise()
{
	// Optimise any local functions.
	TqUint i;
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
			gLocalFuncs[i].pDefNode()->Optimise();
	}

	if(ParseTreePointer)
		ParseTreePointer->Optimise();
}


CqString strNameSpace()	
{
	CqString strRes("");

	if(!ParseNameSpaceStack.empty())
		strRes=ParseNameSpaceStack.back();

	return(strRes);
}

void InitStandardNamespace()
{
	ParseNameSpaceStack.push_back("");
}

void ProcessShaderArguments( CqParseNode* pArgs )
{
	if(pArgs)
	{
		// Each child of the variable_definitions is a CqParseNodeVariable
		CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());

		while(pVar)
		{
			// If storage is not specified, a shader parameter defaults to uniform.
			pVar->SetDefaultStorage(Type_Uniform);
			// Force the variable to be a parameter.
			pVar->SetParam();

			// Check if a default value has been specified.
			CqParseNode* pDefValue=pVar->pFirstChild();
			if(pDefValue!=0)
			{
				// Get a pointer to the local variable.
				CqVarDef* pVarDef=CqVarDef::GetVariablePtr(pVar->VarRef());
				if(pVarDef!=0)
				{
					CqParseNode Node;
					pDefValue->UnLink();
					CqParseNodeCast* pCast=new CqParseNodeCast(pVarDef->Type());
					Node.AddLastChild(pCast);
					pCast->AddLastChild(pDefValue);
					Node.Optimise();
					pVarDef->SetpDefValue(Node.pFirstChild());
					pVar->AddFirstChild( Node.pFirstChild() );
				}
			}
			pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
		}
	}
}


} // End Namespace

static void yyerror(const CqString Message)
{
	ParseSucceeded = false;
	//(*ParseErrorStream) << "libslparse > parser > error: " << Message.c_str() << " at " << ParseStreamName.c_str() << " line " << ParseLineNumber << std::endl;
	CqString strErr( ParseStreamName.c_str() );
	strErr += " : ";
	strErr += ParseLineNumber;
	strErr += " : ";
	strErr += Message.c_str();
	throw( strErr );
}

